
# === Generation of the FS tiled programs (using "mppcodegen") ===

# Usage of the python script:
#	python3.6 gen_tied_prog.py [tiling exploration options]
# List of tiling exploration options:
#		* "single [list of ts]"
#		* "rectangle [mints] [maxts]"
#		* "cross [centralts] d"

import subprocess
import re, sys
import os.path

# Problem definition (to be changed across kernels)
kernel_name = "symm"
prog_sizes = ["1000", "1200"]
kernel_arguments = [
	"int M",
	"int N",
  	"double POLYBENCH_2D(A,M,M, M,M)",
  	"double POLYBENCH_2D(B,M,N, M,N)",
  	"double POLYBENCH_2D(C,M,N, M,N)",
  	"double POLYBENCH_2D(temp2,M,N, M,N)",
  	"double alpha",
  	"double beta"
  ]


utilities_folder_path = "../../../utilities"
# linear-algebra : 3 "../"
# others: 2 "../"

vectorization_report_enable = False

dim_tile_size = 3

# Launch script!
exec(open(utilities_folder_path + "/script_common_gen_tiled.py").read())
