
# === Generation of the FS tiled programs (using "mppcodegen") ===

# Usage of the python script:
#	python3.6 gen_tied_prog.py [tiling exploration options]
# List of tiling exploration options:
#		* "single [list of ts]"
#		* "rectangle [mints] [maxts]"
#		* "cross [centralts] d"

import subprocess
import re, sys
import os.path

# Problem definition (to be changed across kernels)
kernel_name = "doitgen"
prog_sizes = ["160", "140", "150"]
kernel_arguments = [
	"int NP",
	"int NQ",
	"int NR",
  	"double POLYBENCH_3D(A, NR,NQ,NP, NR,NQ,NP)",
  	"double POLYBENCH_2D(C4, NP,NP, NP,NP)",
  	"double POLYBENCH_3D(sum, NR,NQ,NP, NR,NQ,NP)"
  ]

utilities_folder_path = "../../../utilities"
# linear-algebra : 3 "../"
# others: 2 "../"

vectorization_report_enable = False

dim_tile_size = 4

# Launch script!
exec(open(utilities_folder_path + "/script_common_gen_tiled.py").read())
