
# === Generation of the FS tiled programs (using "mppcodegen") ===

# Usage of the python script:
#	python3.6 gen_tied_prog.py [tiling exploration options]
# List of tiling exploration options:
#		* "single [list of ts]"
#		* "rectangle [mints] [maxts]"
#		* "cross [centralts] d"

import subprocess
import re, sys
import os.path

# Problem definition (to be changed across kernels)
kernel_name = "jacobi-1d"
prog_sizes = ["32000", "2000"]
kernel_arguments = [
	"int N",
	"int TSTEPS",
  	"double POLYBENCH_1D(A, N,N)",
  	"double POLYBENCH_1D(B, N,N)"
  ]


utilities_folder_path = "../../utilities"
# linear-algebra : 3 "../"
# others: 2 "../"

vectorization_report_enable = False

dim_tile_size = 2

# Launch script!
exec(open(utilities_folder_path + "/script_common_gen_tiled.py").read())
