
# === Generation of the FS tiled programs (using "mppcodegen") ===

# Usage of the python script:
#	python3.6 gen_tied_prog.py [tiling exploration options]
# List of tiling exploration options:
#		* "single [list of ts]"
#		* "rectangle [mints] [maxts]"
#		* "cross [centralts] d"

import subprocess
import re, sys
import os.path

# Problem definition (to be changed across kernels)
kernel_name = "heat-3d-perfect"
prog_sizes = ["128", "200"]
#prog_sizes = ["128", "512"]  # Takes too much memory when only 8GB of RAM
kernel_arguments = [
	"int N",
	"int TSTEPS",
	"int outer_N", "int inner_N",
	"int outer_TSTEPS", "int inner_TSTEPS",
  	"double POLYBENCH_4D(A, TSTEPS+1,N+1,N+1,N+1, TSTEPS+1,N+1,N+1,N+1)",
  	"int block_size"
  ]

utilities_folder_path = "../../utilities"
# linear-algebra : 3 "../"
# others: 2 "../"

vectorization_report_enable = False

dim_tile_size = 4

# Launch script!
exec(open(utilities_folder_path + "/script_common_gen_tiled.py").read())
